VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cWhoIs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Public Enum ZoneIP
        zoRU = 0
        zoCOM = 1
        zoNET = 2
        zoORG = 3
        zoSU = 4
        zoEU = 5
        zoDE = 6
End Enum

Private Const cIPPort = 43
'Private Const cWhoIsServer = "whois.networksolutions.com"
Private Const cWhoIsServer = "whois.ripn.net"


Private mDtmStart As Date

Private arr() As String

Private LastIP As String
Private SocketNum As Long
Private StartRCV As Boolean
Private WithEvents DataTimer As Timer
Attribute DataTimer.VB_VarHelpID = -1

'local variable(s) to hold property value(s)
Private mLngTimeout As Long
Private mvarPortForListen As Long 'local copy
Private mvarServerIPAddress As String 'local copy
Private mvarDomainName As String 'local copy
Private mvarReturnMessage As String 'local copy
Private mvarHostName As String 'local copy
Private mvarZone As ZoneIP 'local copy
Private mvarOrganization As String 'local copy
Private mvarDescription As String 'local copy
Private mvarAddress As String 'local copy
'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent OnConnect[(arg1, arg2, ... , argn)]
Public Event OnConnect()
Public Event ReturnMSG(ByVal Msg As String)
Public Event ServerIPChanged(ByVal NewIP As String)
Public Event HostIPChanged(ByVal NewIP As String)
Public Event HostDescription(ByVal NewDesc As String)
Public Event HostOrganization(ByVal NewOrg As String)
Public Event HostAddress(ByVal NewVal As String)
'

Public Property Let Address(ByVal vData As String)
    mvarAddress = vData
    RaiseEvent HostAddress(mvarAddress)
End Property

Public Property Get Address() As String
    Address = mvarAddress
End Property

Public Property Let Description(ByVal vData As String)
        
        mvarDescription = vData
        RaiseEvent HostDescription(mvarDescription)

End Property

Public Property Get Description() As String
    Description = mvarDescription
End Property

Public Property Let Organization(ByVal vData As String)
        mvarOrganization = vData
        RaiseEvent HostOrganization(mvarOrganization)

End Property

Public Property Get Organization() As String
    Organization = mvarOrganization
End Property
'
Public Property Let Zone(ByVal vData As ZoneIP)
    mvarZone = vData
End Property

Public Property Get Zone() As ZoneIP
    Zone = mvarZone
End Property

Public Property Let HostName(ByVal vData As String)
Dim mHostIP As String
        mvarHostName = vData
        If vData <> "" Then
                mHostIP = WSOCK.VBGetHostByName(vData)
                RaiseEvent HostIPChanged(mHostIP)
                
                Me.DomainName = GetZoneWhoIsServer(mvarHostName)
                
        End If
        
End Property

Public Property Get HostName() As String
    HostName = mvarHostName
End Property

Public Property Let ReturnMessage(ByVal vData As String)
Dim lLngCopyStart
Dim i As Integer

'

        mvarReturnMessage = vData
'        lLngCopyStart = InStr(1, mvarReturnMessage, "domain:", vbTextCompare)
'        If lLngCopyStart > 0 Then
'            mvarReturnMessage = Mid(mvarReturnMessage, lLngCopyStart)
'        End If
'        lLngCopyStart = InStr(1, mvarReturnMessage, "Registrant:", vbTextCompare)
'        If lLngCopyStart > 0 Then
'            mvarReturnMessage = Mid(mvarReturnMessage, lLngCopyStart + Len("Registrant:"))
'        End If
        mvarReturnMessage = VBA.Replace(mvarReturnMessage, vbCr, "", , , vbTextCompare)
        DoEvents
        mvarReturnMessage = VBA.Replace(mvarReturnMessage, vbLf, vbCrLf, , , vbTextCompare)
        DoEvents
        
        Select Case Zone
                Case zoRU, zoSU, zoEU, zoDE
                        
                        arr = VBA.Split(mvarReturnMessage, vbCrLf, , vbTextCompare)
                        mvarReturnMessage = ""
                        For i = 0 To UBound(arr)
                                If arr(i) <> "" Then
                                        lLngCopyStart = VBA.InStr(1, arr(i), "%", vbTextCompare)
                                        If lLngCopyStart = 1 Then
                                        Else
                                                mvarReturnMessage = mvarReturnMessage & arr(i) & vbCrLf
                                        End If
                                End If
                        Next i
                        
                Case Else
                        'networksolution
                        lLngCopyStart = VBA.InStr(1, mvarReturnMessage, " policy.", vbTextCompare)
                        If lLngCopyStart > 0 Then
                            mvarReturnMessage = VBA.Mid$(mvarReturnMessage, lLngCopyStart + Len(" policy."))
                        End If
                        'register.com
                        lLngCopyStart = VBA.InStr(1, mvarReturnMessage, " you agree to abide by these terms.", vbTextCompare)
                        If lLngCopyStart > 0 Then
                            mvarReturnMessage = VBA.Mid$(mvarReturnMessage, lLngCopyStart + Len(" you agree to abide by these terms."))
                        End If
                        
        End Select
        
        RaiseEvent ReturnMSG(mvarReturnMessage)
        
        Me.Description = GetDescription(mvarReturnMessage)
        Me.Organization = GetOrganization(mvarReturnMessage)
        
End Property

Public Property Get ReturnMessage() As String
    ReturnMessage = mvarReturnMessage
End Property
'
Public Property Let DomainName(ByVal vData As String)
        mvarDomainName = vData
        If vData <> "" Then
                Me.ServerIPAddress = WSOCK.VBGetHostByName(vData)
        End If
End Property

Public Property Get DomainName() As String
    DomainName = mvarDomainName
End Property

Public Property Let ServerIPAddress(ByVal vData As String)
    mvarServerIPAddress = vData
    RaiseEvent ServerIPChanged(vData)
    
End Property

Public Property Get ServerIPAddress() As String
    ServerIPAddress = mvarServerIPAddress
End Property

Public Property Let PortForListen(ByVal vData As Long)
    mvarPortForListen = vData
End Property

Public Property Get PortForListen() As Long
    PortForListen = mvarPortForListen
End Property

Public Function ConnectToServer(ByVal HostName As String) As Boolean
Dim Async%
Dim retIpPort As String
Dim b As Boolean
Dim desc As String
        
        ConnectToServer = False
        DataTimer.Enabled = False
        Me.ReturnMessage = ""
        Me.Address = ""
        Screen.MousePointer = 11
        
        If HostName = "" Then GoTo lb_out
         If Not WSAStartedUp Then
'                WSOCK.EndWinsock
lb_start:
                b = WSOCK.StartWinsock(desc)
                If b = 0 Then
                         GoTo lb_out
                End If
'        Else
'                GoTo lb_start
        End If
        If VBA.InStr(1, HostName, "-", vbTextCompare) Then
        Else
        Me.HostName = HostName
        End If
        If Me.ServerIPAddress = "" Then GoTo lb_out
        
        mDtmStart = Now()
        SocketNum = WSOCK.ConnectSock(Me.ServerIPAddress, Me.PortForListen, retIpPort, f_Main.hwnd, Async)
        If SocketNum < 1 Then
                GoTo lb_out
        End If
'        RaiseEvent OnConnect
        DataTimer.Enabled = True
        b = WSOCK.SendData(SocketNum, HostName & vbCrLf)
        ConnectToServer = True
lb_out:
        Screen.MousePointer = 0
End Function

Private Sub Class_Initialize()
Dim b As Boolean
Dim desc As String

         If Not WSAStartedUp Then
                b = WSOCK.StartWinsock(desc)
        End If
        Set DataTimer = f_Main.TMR
        DataTimer.Interval = 10
        mLngTimeout = 10
        Me.DomainName = cWhoIsServer
        Me.PortForListen = cIPPort
        
End Sub

Private Sub Class_Terminate()

         If WSAStartedUp Then
                WSOCK.EndWinsock
        End If
        DataTimer.Enabled = False
        Set DataTimer = Nothing
        
End Sub

Private Sub DataTimer_Timer()
        ReceiveData
End Sub

Private Sub ReceiveData()
On Error GoTo err_debug

Dim fixstr As String * 4096
Dim i%
Dim RecvBuffer As String
Dim buffer As String
Dim retf As Long

        fixstr = ""
        RecvBuffer = ""
        'If the socket is less than or = to 0 then on one is
        'connected on that user.
        If SocketNum <= 0 Then Exit Sub
        'receives data on connection
        retf = recv(SocketNum, fixstr, 4096, 0)
        'Pick the info out of the junk
        If retf > 0 Then
                RecvBuffer = Left$(fixstr, retf)
        End If
        If RecvBuffer <> "" Then
                'We got some data
                buffer = RecvBuffer
                'Sends to be stripped and used properly
                ExecuteReceiveData buffer, SocketNum
        End If
        
lb_out:
        DoEvents
Exit Sub
err_debug:
        Resume lb_out

End Sub

Private Sub ExecuteReceiveData(ReceivedData As String, OrigSock As Long)

        If Not mvarReturnMessage = "" Then
                mvarReturnMessage = mvarReturnMessage & vbCrLf
        End If
        mvarReturnMessage = mvarReturnMessage & ReceivedData
        Me.ReturnMessage = mvarReturnMessage
End Sub

Public Property Get Timeout() As Long
    
    Timeout = mLngTimeout

End Property

Public Property Let Timeout(ByVal pLngSeconds As Long)
    
    mLngTimeout = pLngSeconds

End Property

Private Function GetZoneWhoIsServer(ByVal sHostName As String) As String
Dim i As Integer
Dim suff As String
        
        i = VBA.InStrRev(sHostName, ".", , vbTextCompare)
        If i = 0 Then Exit Function
        
        suff = VBA.UCase$(VBA.Mid$(sHostName, i + 1))
        Select Case suff
                Case "RU", "SU"
                        Zone = zoRU
                        GetZoneWhoIsServer = "whois.ripn.net"
                Case "COM", "NET", "ORG"
                        Zone = zoCOM
                        GetZoneWhoIsServer = "whois.networksolutions.com"
                Case "NL", "LV"
                        Zone = zoEU
                        GetZoneWhoIsServer = "whois.ripe.net"
                Case "DE"
                        Zone = zoDE
                        GetZoneWhoIsServer = "whois.nic.de"
                Case Else
                        Zone = zoCOM
                        GetZoneWhoIsServer = "whois.networksolutions.com"
        End Select
        
End Function

Private Function GetDescription(ByVal Response As String) As String
Dim i As Integer
Dim j As Integer
Dim sss As String
Dim sout As String

        sout = ""
        sss = ""
        Select Case Zone
                Case zoRU, zoSU, zoEU, zoDE
                        For j = 0 To UBound(arr)
                                If arr(j) <> "" Then
                                        i = VBA.InStr(1, arr(j), "descr:", vbTextCompare)
                                        If i > 0 Then
                                                sss = VBA.Trim$(VBA.Mid$(arr(j), VBA.Len("descr:") + 1))
                                                If sout <> "" Then
                                                        sout = sout & " " & sss
                                                Else
                                                        sout = sss
                                                End If
                                        End If
                                End If
                        Next j
                Case Else
                        i = VBA.InStr(1, Response, "Registrant:", vbTextCompare)
                        If i > 0 Then
                                sss = VBA.Mid$(Response, i + VBA.Len("Registrant:") + 2)
                                i = VBA.InStr(1, sss, vbCrLf, vbTextCompare)
                                If i > 0 Then
                                        sss = VBA.Mid$(sss, 1, i - 1)
                                        sout = VBA.Trim$(sss)
                                End If
                        End If
        End Select
        GetDescription = sout
        
        
End Function

Private Function GetOrganization(ByVal Response As String) As String
Dim i As Integer
Dim j As Integer
Dim sss As String
Dim sout As String

        sout = ""
        sss = ""
        Select Case Zone
                Case zoRU, zoSU, zoEU, zoDE
                        For j = 0 To UBound(arr)
                                If arr(j) <> "" Then
                                        i = VBA.InStr(1, arr(j), "org:", vbTextCompare)
                                        If i > 0 Then
                                                sss = VBA.Trim$(VBA.Mid$(arr(j), VBA.Len("org:") + 1))
                                                If sout <> "" Then
                                                        sout = sout & " " & sss
                                                Else
                                                        sout = sss
                                                End If
                                        End If
                                End If
                        Next j
                        
                        i = VBA.InStr(1, Response, "person:", vbTextCompare)
                        If i > 0 Then
                                sss = VBA.Mid$(Response, i)
                                i = VBA.InStr(2, sss, "person:", vbTextCompare)
                                If i > 0 Then
                                        sss = VBA.Mid$(sss, 1, i - 1)
                                End If
                                arr = VBA.Split(sss, vbCrLf, , vbTextCompare)
                                Dim sadd As String
                                For j = 1 To UBound(arr)
                                        If arr(j) <> "" Then
                                                i = VBA.InStr(1, arr(j), "address:", vbTextCompare)
                                                If i > 0 Then
                                                        sss = VBA.Trim$(VBA.Mid$(arr(j), VBA.Len("address:") + 1))
                                                        If sadd <> "" Then
                                                                sadd = sadd & vbCrLf & VBA.Trim$(sss)
                                                        Else
                                                                sadd = sss
                                                        End If
                                                End If
                                        End If
                                Next j
                                If sadd <> "" Then
                                        Me.Address = sadd
                                End If
                        End If
                Case Else
                        i = VBA.InStr(1, Response, "Registrant:", vbTextCompare)
                        If i > 0 Then
                                sss = VBA.Mid$(Response, i + VBA.Len("Registrant:") + 2)
                                i = VBA.InStr(1, sss, vbCrLf, vbTextCompare)
                                If i > 0 Then
                                        Me.Address = GetAddress(sss)
                                        sss = VBA.Mid$(sss, 1, i - 1)
                                        sout = VBA.Trim$(sss)
                                End If
                        Else
                                i = VBA.InStr(1, Response, "Organization:", vbTextCompare)
                                If i > 0 Then
                                        sss = VBA.Mid$(Response, i + VBA.Len("Organization:") + 2)
                                        i = VBA.InStr(1, sss, vbCrLf, vbTextCompare)
                                        If i > 0 Then
                                                Me.Address = GetAddress(sss)
                                                sss = VBA.Mid$(sss, 1, i - 1)
                                                sout = VBA.Trim$(sss)
                                        End If
                                End If
                        End If
        End Select
        GetOrganization = sout
        
        
End Function

Private Function GetAddress(ByVal NewVal As String) As String
Dim i As Integer
Dim sss As String
        
        sss = ""
        arr = VBA.Split(NewVal, vbCrLf, , vbTextCompare)
        If UBound(arr) > 1 Then
        
                For i = 1 To UBound(arr)
                        
                        If arr(i) = "" Then
                                Exit For
                        End If
                        If arr(i) <> "" Then
                                sss = sss & VBA.Trim$(arr(i)) & vbCrLf
                        End If
                Next i
                
                sss = VBA.Trim$(sss)
                If sss <> "" Then
                sss = VBA.Mid$(sss, 1, VBA.Len(sss) - 2)
                End If
        End If
        GetAddress = sss
        
End Function
